package aimas2014.goals;

import java.util.HashSet;
import java.util.Set;

import aimas2014.search.MarsSearchNode;
import aimas2014.search.SearchNodeType;
import aimas2014.search.TargetedSearchNode;
import aimas2014.search.actions.ActionType;
import aimas2014.search.actions.ParryAction;

public class ParryGoal extends MarsMapGoal {

    @Override
    public boolean suceeded(SearchNodeType s) {
        if (!(s instanceof TargetedSearchNode))
            return false;
        
        MarsSearchNode n = (MarsSearchNode) s;
        
        return n.nodeParried;
    }
    
    private final static Set<ActionType> actionsRequired = new HashSet<>();

	@Override
	public Set<ActionType> actionsRequired() {
		if (0 == actionsRequired.size()) {
			actionsRequired.add(new ParryAction());
			actionsRequired.addAll(super.actionsRequired());
		}
		
		return actionsRequired;
	}
}