package aimas2014.goals;

import java.util.HashSet;
import java.util.List;
import java.util.Set;

import aimas2014.environment.MarsNode;
import aimas2014.planning.AgentPlan;
import aimas2014.planning.LocalBeliefs;
import aimas2014.search.BestFirstSearch;
import aimas2014.search.BestFirstSearch.Solution;
import aimas2014.search.BestFirstSearch.StepComparator;
import aimas2014.search.MarsSearchNode;
import aimas2014.search.SearchNodeType;
import aimas2014.search.actions.ActionType;
import aimas2014.search.actions.RepairAction;
import aimas2014.search.actions.SurveyAction;

public class SurveyNodeGoal extends TargetedMarsMapGoal {


	public SurveyNodeGoal(MarsNode targetNode) {
		super(targetNode);
    }

    @Override
    public boolean suceeded(SearchNodeType s) {
        if (!(s instanceof MarsSearchNode))
            return false;
        
        MarsSearchNode n = (MarsSearchNode) s;
        
        return n.node.equals(target.getPosition()) && n.nodeSurveyed;
    }

    @Override
    public AgentPlan producePlan(LocalBeliefs beliefs, List<ActionType> actionLibrary) {
        MarsSearchNode initial = new MarsSearchNode(beliefs.position, beliefs.energy, beliefs.maxEnergy);
        
        Solution sol = BestFirstSearch.plan(initial, actionLibrary, this, new StepComparator());

        return BestFirstSearch.reconstructPlan(sol);
    }
    
    private final static Set<ActionType> actionsRequired = new HashSet<>();
    
	@Override
	public Set<ActionType> actionsRequired() {
		if (0 == actionsRequired.size()) {
			actionsRequired.add(new SurveyAction());
		}
		
		return actionsRequired;
	}
}