package aimas2014.search.instantiations;

import massim.javaagents.agents.MarsUtil;
import aimas2014.environment.MarsNode;
import aimas2014.search.MarsSearchNode;
import aimas2014.search.SearchNodeType;
import aimas2014.search.actions.ActionType.InstantiatedAction;
import eis.iilang.Action;

public class InstantiatedGotoAction extends InstantiatedAction {
    private final MarsNode toNode;
    private final int edgeCost;

    public InstantiatedGotoAction(MarsNode toNode, int edgeCost) {
        super();
        this.toNode = toNode;
        this.edgeCost = edgeCost;
    }
    
    @Override
    public Action realize() {
        return MarsUtil.gotoAction(toNode.name);
    }
    
    public SearchNodeType apply(SearchNodeType s) {
        return ((MarsSearchNode) s.copy()).step().cost(edgeCost).moved(toNode);
    }
    
    public boolean isApplicable(SearchNodeType s) {
		MarsSearchNode fromNode = (MarsSearchNode) s;
		
		if (fromNode.node.equals(toNode))
			return false;
		
		return fromNode.currentEnergy >= edgeCost;
    }
    
    @Override
    public int hashCode() {
        return ("goto" + toNode.name).hashCode();
    }

	@Override
	public boolean equals(Object obj) {
		if (obj instanceof InstantiatedGotoAction) {
			InstantiatedGotoAction other = (InstantiatedGotoAction) obj;
			
			return toNode.equals(other.toNode) && edgeCost == other.edgeCost;
		}
		
		return false;
	}
}