package aimas2014.search.instantiations;

import massim.javaagents.agents.MarsUtil;
import aimas2014.search.MarsSearchNode;
import aimas2014.search.SearchNodeType;
import aimas2014.search.actions.ActionType.InstantiatedAction;
import eis.iilang.Action;

public final class InstantiatedParryAction extends InstantiatedAction {
    @Override
    public Action realize() {
        return MarsUtil.parryAction();
    }

    @Override
    public SearchNodeType apply(SearchNodeType s) {
        return ((MarsSearchNode) s.copy()).step().cost(2).parried();
    }

    @Override
    public int hashCode() {
        return "parry".hashCode();
    }
    
    @Override
    public boolean equals(Object obj) {
    	return obj instanceof InstantiatedParryAction;
    }

	@Override
	public boolean isApplicable(SearchNodeType s) {
		MarsSearchNode fromNode = (MarsSearchNode) s;
		
		return !fromNode.nodeParried && fromNode.currentEnergy >= 2;
	}
}